#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright (C) 2007 Pâris Quentin

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. 

import wxversion, os, sys, codecs, string
wxversion.select("2.8")
import wx

import lib.Variables as Variables
import lib.lng

class MainWindow(wx.Frame):
  def __init__(self,parent,id,title):
    wx.Frame.__init__(self, parent, -1, title, size = (792, 573), style = wx.CLOSE_BOX | wx.CAPTION | wx.MINIMIZE_BOX)
    self.panelFenp = wx.Panel(self, -1)
    self.live = 0
    self.SetIcon(wx.Icon(Variables.playonlinux_env+"/etc/playonlinux.png", wx.BITMAP_TYPE_ANY))
    self.images_cat = wx.ImageList(22, 22)
    self.imagesapps = wx.ImageList(22, 22)
    self.list_cat = wx.TreeCtrl(self.panelFenp, 105, style=wx.TR_HIDE_ROOT|wx.TR_FULL_ROW_HIGHLIGHT|wx.RAISED_BORDER, size=(200, 343), pos=(10,10))
    self.image = wx.StaticBitmap(self.panelFenp, -1, wx.Bitmap(Variables.playonlinux_env+"/etc/pol_min.png"), (10,363), wx.DefaultSize)
    self.list_cat.SetSpacing(0);
    self.list_cat.SetImageList(self.images_cat)
    self.AddCats()
    self.searchbox = wx.TextCtrl(self.panelFenp, 110, size=(464,25), pos=(319,9))
    self.searchcaption = wx.StaticText(self.panelFenp, -1, _("Search :"), (220,15), wx.DefaultSize)
    self.list_apps = wx.TreeCtrl(self.panelFenp, 106, style=wx.TR_HIDE_ROOT|wx.TR_FULL_ROW_HIGHLIGHT|wx.RAISED_BORDER, size=(562, 251), pos=(220,40))
    self.list_apps.SetImageList(self.imagesapps)
    self.list_apps.SetSpacing(0);
    self.content =  wx.TextCtrl(self.panelFenp, 107, pos=(220,301), size=(562,212), style = wx.TE_MULTILINE | wx.TE_RICH2 | wx.CB_READONLY | wx.RAISED_BORDER)

    self.button = wx.Button(self.panelFenp, wx.ID_CLOSE, pos=(576, 525), size=(100,35))
    self.install_button = wx.Button(self.panelFenp, wx.ID_APPLY, pos=(683, 525), size=(100,35))
    self.update_button = wx.Button(self.panelFenp, wx.ID_REFRESH, pos=(470, 525), size=(100,35))
    self.install_button.Enable(False)
    
    #self.ManualInstall = wx.CheckBox(self.panelFenp, 111, label=_("Install a .pol package or an unsupported application"), pos=(10,530))
    self.ManualInstall = wx.HyperlinkCtrl(self.panelFenp, 111, _("Install a .pol package or an unsupported application"), "", pos=(10,535))
    self.ManualInstall.SetNormalColour(wx.Colour(0,0,0))
   # self.AddApps()

    wx.EVT_TREE_SEL_CHANGED(self, 105, self.AddApps)
    wx.EVT_TREE_SEL_CHANGED(self, 106, self.AppsDetails)
    wx.EVT_BUTTON(self, wx.ID_CLOSE, self.closeapp)
    wx.EVT_BUTTON(self, wx.ID_APPLY, self.installapp)
    wx.EVT_BUTTON(self, wx.ID_REFRESH, self.UpdatePol)
    wx.EVT_TREE_ITEM_ACTIVATED(self, 106, self.installapp)
    wx.EVT_TEXT(self, 110, self.search)
    wx.EVT_HYPERLINK(self, 111, self.manual)
    #wx.EVT_CHECKBOX(self, 111, self.manual)
    #Timer, regarde toute les secondes si il faut actualiser la liste

   
  def closeapp(self, event):
	self.Close()   
	sys.exit(1)   

  def manual(self, event):
	self.live = 1
	self.installapp(self)
  #def manual(self, event):
#	if(self.ManualInstall.IsChecked() == 1):
#		self.list_apps.Enable(False)
#		self.list_cat.Enable(False)
#		self.searchbox.Enable(False)
#		self.install_button.Enable(True)
#		self.content.Enable(False)
#		self.AddCats()
#		self.DelApps()
#		self.ResetImg()
#	else:
#		self.list_apps.Enable(True)
##		self.list_cat.Enable(True)
#		self.searchbox.Enable(True)
#		self.content.Enable(True)
#		self.install_button.Enable(False)

  def UpdatePol(self, event):
	self.DelApps()
	os.system("bash \""+Variables.playonlinux_env+"/bash/check_maj\"&")
	
  def installapp(self, event):
	if(self.live == 1):
		print "ExecLiveInstall"
	else:
		print self.list_apps.GetItemText(self.list_apps.GetSelection())
	self.Close()   
	sys.exit(0) 

  def search(self, event):
	self.apps = codecs.open(Variables.playonlinux_rep+"/configurations/listes/search",'r',"utf-8")
	self.apps = self.apps.readlines()
	self.j = 0;
	while(self.j < len(self.apps)):
		self.apps[self.j] = self.apps[self.j].replace("\n","")
		self.j += 1

	self.j = 0;
	self.k = 0;
	self.user_search =self.searchbox.GetValue()
	self.search_result = []

	while(self.j < len(self.apps)):
		if(string.lower(self.user_search) in string.lower(self.apps[self.j])):
			#self.search_result[self.k] = self.apps[self.j]
			self.search_result.append(self.apps[self.j])
			self.k = self.k + 1;
		self.j = self.j + 1;

	if(self.user_search != ""):
		self.WriteApps(self.search_result)
	else:
		self.DelApps()

  def EraseDetails(self):
    self.content.SetValue("");
 
  def AppsDetails(self, event):
    self.install_button.Enable(True)
    self.description_look_for = Variables.playonlinux_rep+"/configurations/descriptions/"+self.list_apps.GetItemText(self.list_apps.GetSelection())
    if(os.path.exists(self.description_look_for)):
	self.des = open(self.description_look_for,'r')
  	self.content.SetValue(self.des.read())
    else:
   	 self.content.SetValue(_("No description."))	
    self.image_look_for = Variables.playonlinux_rep+"/configurations/miniatures/"+self.list_apps.GetItemText(self.list_apps.GetSelection())
    
    if(os.path.exists(self.image_look_for)):
	    self.SetImg(self.image_look_for)
    else:
	    self.SetImg(Variables.playonlinux_env+"/etc/pol_min.png")

  def AddCats(self):
    self.cats = [_("Accessories"),_("Development"),_("Education"),_("Games"),_("Graphics"),_("Internet"),_("Multimedia"),_("Office"),_("Other")]
    self.images_cat.RemoveAll()
    self.images_cat.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/applications-accessories.png"))
    self.images_cat.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/applications-development.png"))
    self.images_cat.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/edu.png"))
    self.images_cat.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/applications-games.png"))
    self.images_cat.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/applications-graphics.png"))
    self.images_cat.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/applications-internet.png"))
    self.images_cat.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/applications-multimedia.png"))
    self.images_cat.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/applications-office.png"))
    self.images_cat.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/applications-other.png"))
#    self.cats.sort()
    self.list_cat.DeleteAllItems()
    self.root = self.list_cat.AddRoot("")
    self.i = 0
    for cat in self.cats:
	self.list_cat.AppendItem(self.root, cat, self.i)
	self.i = self.i+1

  def WriteApps(self, array):
	self.imagesapps.RemoveAll()

	self.DelApps()
	self.root_apps = self.list_apps.AddRoot("")
	self.i = 0
	array.sort()
	for app in array:
		self.icon_look_for = Variables.playonlinux_rep+"/configurations/icones/"+app
		if(os.path.exists(self.icon_look_for)):
			self.imagesapps.Add(wx.Bitmap(self.icon_look_for))
		else:	
			self.imagesapps.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/playonlinux22.png"))
		self.list_apps.AppendItem(self.root_apps, app, self.i)
		self.i = self.i+1

  def DelApps(self):
	self.list_apps.DeleteAllItems()

  def SetImg(self, image):
	self.image.Destroy()
	self.image = wx.StaticBitmap(self.panelFenp, -1, wx.Bitmap(image), (10,363), wx.DefaultSize)

  def ResetImg(self):
	self.SetImg(Variables.playonlinux_env+"/etc/pol_min.png")

  def AddApps(self, event):
	self.searchbox.SetValue("")
	#self.cat_selected=self.list_cat.GetItemText(self.list_cat.GetSelection()).encode('utf-8')
	self.cat_selected = self.list_cat.GetItemImage(self.list_cat.GetSelection())
	#print self.cat_selected
	if(self.cat_selected == 8):
		self.apps = codecs.open(Variables.playonlinux_rep+"/configurations/listes/0",'r',"utf-8")
	if(self.cat_selected == 3):
		self.apps = codecs.open(Variables.playonlinux_rep+"/configurations/listes/1",'r',"utf-8")
	if(self.cat_selected == 0):
		self.apps = codecs.open(Variables.playonlinux_rep+"/configurations/listes/2",'r',"utf-8")
	if(self.cat_selected == 7):
		self.apps = codecs.open(Variables.playonlinux_rep+"/configurations/listes/3",'r',"utf-8")
	if(self.cat_selected == 5):
		self.apps = codecs.open(Variables.playonlinux_rep+"/configurations/listes/4",'r',"utf-8")
	if(self.cat_selected == 6):
		self.apps = codecs.open(Variables.playonlinux_rep+"/configurations/listes/5",'r',"utf-8")
	if(self.cat_selected == 4):
		self.apps = codecs.open(Variables.playonlinux_rep+"/configurations/listes/6",'r',"utf-8")
	if(self.cat_selected == 1):
		self.apps = codecs.open(Variables.playonlinux_rep+"/configurations/listes/7",'r',"utf-8")
	if(self.cat_selected == 2):
		self.apps = codecs.open(Variables.playonlinux_rep+"/configurations/listes/8",'r',"utf-8")

	self.apps = self.apps.readlines()
	self.j = 0
	while(self.j < len(self.apps)):
		self.apps[self.j] = self.apps[self.j].replace("\n","")
		self.j += 1
	self.WriteApps(self.apps)

class PlayOnLinuxApp(wx.App):
   def OnInit(self):
	frame = MainWindow(None, -1, "PlayOnLinux")
        self.SetTopWindow(frame)
	frame.Center(wx.BOTH)
        frame.Show(True)
        return True

lib.lng.Lang()
app = PlayOnLinuxApp()
app.MainLoop()
