#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright (C) 2007 Pâris Quentin

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. 


import wxversion
wxversion.select("2.8")
import wx, wx.html
import gettext, os, getopt, sys, urllib, signal, socket, string, time, threading
import lib.Variables as Variables, lib.lng as lng
import lib.irc as irc

class Onglets(wx.Notebook):
	# Classe dérivée du wx.Notebook
	def __init__(self, parent):
		self.notebook = wx.Notebook.__init__(self, parent, -1)
		self.images_onglets = wx.ImageList(16, 16)
    		self.images_onglets.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/input-gaming.png"));
  		self.images_onglets.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/internet-group-chat.png"));
   		self.SetImageList(self.images_onglets)

	def AjouteListe(self, nom):
		self.images = wx.ImageList(32, 32)
		if(len(sys.argv) > 1):
			self.panel_games = wx.Panel(self, -1)
			self.panel_update = wx.Panel(self.panel_games, -1)
			#self.panel_update.SetBackgroundColour((255,255,225))
			self.fontText = wx.Font(10, wx.FONTFAMILY_DEFAULT, wx.FONTSTYLE_NORMAL, wx.FONTWEIGHT_BOLD,False, "", wx.FONTENCODING_DEFAULT)
			self.image_logo = wx.StaticBitmap(self.panel_update, -1, wx.Bitmap(Variables.playonlinux_env+"/etc/playonlinux16.png"), pos=(15,0))
			self.texte_update = wx.StaticText(self.panel_update, -1, _("An updated version of PlayOnLinux is available. Please visit the website."),pos=(35,0))
			self.texte_update.SetFont(self.fontText)
			self.list_game = wx.TreeCtrl(self.panel_games, 105, style=wx.TR_HIDE_ROOT|wx.TR_FULL_ROW_HIGHLIGHT)
	
			self.sizer_games = wx.BoxSizer(wx.VERTICAL)
			self.sizer_games.Add(self.panel_update, 1, wx.EXPAND|wx.ALL, 2)
			self.sizer_games.Add(self.list_game, 20, wx.EXPAND|wx.ALL, 2)
			
			self.panel_games.SetSizer(self.sizer_games)
			self.panel_games.SetAutoLayout(True)
	
			self.AddPage(self.panel_games, nom, imageId=0)
		else :
			self.list_game = wx.TreeCtrl(self, 105, style=wx.TR_HIDE_ROOT|wx.TR_FULL_ROW_HIGHLIGHT)	
			self.AddPage(self.list_game, nom, imageId=0)
		self.list_game.SetSpacing(0);
		self.list_game.SetImageList(self.images)

		

		

	def getSettings(self): # Faudra revoir ça dans une future version
		irc_settings = {}
	
		irc_settings['NICKNAME'] = os.popen("printf $USER").read()+"-pol"
		irc_settings['AUTOCONNECT'] = "0"
		irc_settings['ALERT'] = "0"
		irc_settings["PLAYSOUND"] = "1" 
		if(os.path.exists(Variables.playonlinux_rep+"/configurations/options/irc")):
			ircfile = open(Variables.playonlinux_rep+"/configurations/options/irc","r").readlines()
			self.i = 0
		
			while(self.i < len(ircfile)):
				line_parsed = string.split(ircfile[self.i].replace("\n","").replace("\r",""),"=")
				irc_settings[line_parsed[0]] = line_parsed[1]
				self.i += 1
		return irc_settings

	def selectChanByText(self, text):
		self.item = self.root_window
		
		self.ij = 0
		self.texte = None
		while(self.texte != text):
			if(self.ij >= len(irc.chans)):
				return self.window.GetLastChild(self.root_window)

			self.item = self.window.GetNextVisible(self.item)
			self.texte = self.window.GetItemText(self.item)
			self.ij += 1


		return self.item

	def OpenWindow(self):
		#if(nom.lower() not in irc.chans and not "@" in nom and nom != "freenode-connect"):
		#self.old_selection = self.window.GetItemText(self.window.GetSelection())
		self.window.DeleteAllItems()
		self.root_window = self.window.AddRoot("")
		self.i = 0
		while(self.i < len(irc.chans)):
			nom = irc.chans[self.i].lower()
			if("." not in nom and nom != "freenode-connect"):
				if("#" in nom):
					self.window.AppendItem(self.root_window, nom, 0)
				else:
					if(nom.lower() == "nickserv" or nom.lower() == "chanserv" or nom.lower() == "botserv"):
						self.window.AppendItem(self.root_window, nom, 2)
					else:
						if(nom.lower() == "playonlinux"):
							self.window.AppendItem(self.root_window, nom, 3)					
						else:
							self.window.AppendItem(self.root_window, nom, 1)
				#if(self.i == 0):
					#self.window.SelectItem(self.window.GetLastChild(self.root_window))
			self.i += 1	
		#item = self.selectChanByText(self.old_selection)
		#self.window.SelectItem(item)
			#irc.open_window.append(nom.lower())
		
	def selectWindow(self, name):
		item = self.selectChanByText(name)
		self.window.SelectItem(item)

	def AjouteIRC(self, nom):
		self.panel = wx.Panel(self, -1)
		self.panels_button = wx.Panel(self.panel, -1)
		self.panels_main = wx.Panel(self.panel, -1)
		self.panels_connexion = wx.Panel(self.panel, -1)
		#self.content =  wx.TextCtrl(self.panel, 107, pos=(0,20), size=(500,300), style = wx.TE_MULTILINE | wx.TE_RICH2 | wx.CB_READONLY | wx.RAISED_BORDER)
		
		self.content = wx.html.HtmlWindow(self.panels_main, -1, style=wx.RAISED_BORDER)
		self.buddy = wx.TreeCtrl(self.panels_main, 126, style=wx.TR_HIDE_ROOT|wx.TR_FULL_ROW_HIGHLIGHT|wx.RAISED_BORDER)
		self.buddy.SetSpacing(0);

		self.window = wx.TreeCtrl(self.panels_main, 127, style=wx.TR_HIDE_ROOT|wx.TR_FULL_ROW_HIGHLIGHT|wx.RAISED_BORDER)
		#self.root_window = self.window.AddRoot("")
		self.window.SetSpacing(0);
		
		self.buddy_images = wx.ImageList(16, 16)
		self.buddy_images.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/star.png"));
		self.buddy_images.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/h-star.png"));
		self.buddy_images.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/playonlinux16.png"));
		self.buddy_images.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/spacer.png"));
		self.buddy_images.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/install/founder.png"));
		self.buddy.SetImageList(self.buddy_images)

		self.window_images = wx.ImageList(16,16)
		self.window_images.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/internet-group-chat.png"));
		self.window_images.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/system-users.png"));
		self.window_images.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/applications-system.png"));
		self.window_images.Add(wx.Bitmap(Variables.playonlinux_env+"/etc/playonlinux16.png"));
		self.window.SetImageList(self.window_images)

		self.buddy.SetSpacing(0);
		self.field =  wx.TextCtrl(self.panels_button, 121, style = wx.TE_MULTILINE)
		self.button = wx.Button(self.panels_button, 122, _("Send"))
		self.connect = wx.Button(self.panels_connexion, 123, _("Connect"), pos=(0,0), size=(90,28))
		self.disconnect = wx.Button(self.panels_connexion, 124, _("Disconnect"), pos=(100,0), size=(90,28))
		#self.close = wx.Button(self.panels_connexion, 128, _("Close"), pos=(600,0), size=(90,25))
		self.close = wx.BitmapButton(self.panels_connexion, 128, wx.Bitmap(Variables.playonlinux_env+"/etc/menu/wineserver.png"), pos=(713,0))
		self.settings = self.getSettings()
		self.nickname = wx.TextCtrl(self.panels_connexion, 125, self.settings["NICKNAME"], size=(500,28), pos=(200,0))
#		self.close.Enable(False)
		self.sizer = wx.BoxSizer(wx.VERTICAL)
		self.sizerInputs = wx.BoxSizer(wx.HORIZONTAL)
		self.sizerMain = wx.BoxSizer(wx.HORIZONTAL)

		self.sizer.Add(self.panels_connexion, 3, wx.EXPAND|wx.ALL, 2)
		self.sizer.Add(self.panels_main, 36, wx.EXPAND|wx.ALL, 2)
		self.sizer.Add(self.panels_button, 4, wx.EXPAND|wx.ALL, 2)

		self.sizerInputs.Add(self.field, 14, wx.EXPAND|wx.ALL, 2)
		self.sizerInputs.Add(self.button, 4, wx.EXPAND|wx.ALL, 2)

		self.sizerMain.Add(self.window, 4, wx.EXPAND|wx.ALL, 2)
		self.sizerMain.Add(self.content, 10, wx.EXPAND|wx.ALL, 2)
		self.sizerMain.Add(self.buddy, 4, wx.EXPAND|wx.ALL, 2)

		self.panel.SetSizer(self.sizer)
		self.panels_button.SetSizer(self.sizerInputs)
		self.panels_main.SetSizer(self.sizerMain)
		self.panel.SetAutoLayout(True)

		self.AddPage(self.panel, nom, imageId=1)
		self.field.Bind(wx.EVT_KEY_UP, self.EventKey)
		self.nickname.Bind(wx.EVT_KEY_UP, self.NicknameKey)

		wx.EVT_BUTTON(self,  122,  self.EventButton)
		wx.EVT_BUTTON(self,  123,  self.EventStart)
		wx.EVT_BUTTON(self,  124,  self.EventStop)
		wx.EVT_BUTTON(self,  128,  self.EventClose)
		wx.EVT_TREE_ITEM_ACTIVATED(self, 126, self.AddNick)
		#wx.EVT_TREE_ITEM_ACTIVATED(self, 127, self.filtrer)
		self.disconnect.Enable(False)

	def AddNick(self, event):
		self.buddy_txt = self.buddy.GetItemText(self.buddy.GetSelection()).encode("utf-8")
		irc.join(self.buddy_txt)
		#if(self.buddy_txt not in irc.chans):
			
		#self.field.SetValue("/msg "+self.buddy_txt+" ")
		#self.OpenWindow(self.buddy_txt)

	def SendMessage(self):
		self.chars = self.field.GetValue().replace('\n','').encode("utf-8")
		if(self.chars):
			self.field.Clear()
			irc.SendMSG(self.chars)
		else:
			self.field.Clear()
	
	def EventClose(self, event):
		#index = irc.get_index(self.window.GetItemText(self.window.GetSelection()).lower()):
		#print index

		#del irc.messages[index]
		#del irc.names[index]
		#del irc.endnames[index]
		#del irc.chans[index]

		irc.leave_chan(self.window.GetItemText(self.window.GetSelection()).lower())

		self.window.Delete(self.window.GetSelection())
		#self.close.Enable(False)

	def EventStart(self, event):
		irc.Nick = self.nickname.GetValue().encode("utf-8")
		irc.Connexion()

	def EventStop(self, event):
		irc.stop()

	def EventButton(self, event):
		self.SendMessage()

	def EventKey(self, event):
		if(event.GetKeyCode() == wx.WXK_RETURN):
			self.SendMessage()

		event.Skip()

	def NicknameKey(self, event):
		if(event.GetKeyCode() == wx.WXK_RETURN):
			if(irc.ircconnected == True):
				irc.ChangeNick(self.nickname.GetValue().encode("utf-8"))
			else:
				irc.Connexion()
		event.Skip()


class MainWindow(wx.Frame):
  def __init__(self,parent,id,title):
    wx.Frame.__init__(self, parent, -1, title, size = (750, 565))
    self.SetIcon(wx.Icon(Variables.playonlinux_env+"/etc/playonlinux.png", wx.BITMAP_TYPE_ANY))
    self.timer = wx.Timer(self, 1)
    self.onglets = Onglets(self)
    self.onglets.AjouteListe(_("My Applications"))
    self.onglets.AjouteIRC(_("Messenger"))
    self.oldreload = ""
    self.oldimg = ""
    self.names = ["~"]
    self.messages = ["~"]
    self.chans = ["~"]
    self.filemenu = wx.Menu()
    self.filemenu.Append(wx.ID_OPEN, _("Run"))
    self.filemenu.Append(wx.ID_ADD, _("Install"))
    self.remove_item_menu = self.filemenu.Append(wx.ID_DELETE, _("Remove"))
    self.filemenu.Append(wx.ID_REFRESH, _("Update"))
    self.filemenu.AppendSeparator()
    self.filemenu.Append(wx.ID_EXIT, _("Exit"))

    self.expertmenu = wx.Menu()
    self.already_connected = False

    self.settings = self.onglets.getSettings()

    self.wineconfig_item = wx.MenuItem(self.expertmenu, 102, _("Configure wine"))
    self.wineconfig_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/menu/winecfg.png"))
    self.expertmenu.AppendItem(self.wineconfig_item)

#    self.wbooster_item = wx.MenuItem(self.expertmenu, 117, _("Advanced wine configuration"))
 #   self.wbooster_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/menu/wine.png"))
  #  self.expertmenu.AppendItem(self.wbooster_item)

    self.regedit_item = wx.MenuItem(self.expertmenu, 103, _("Registry Editor"))
    self.regedit_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/menu/regedit.png"))
    self.expertmenu.AppendItem(self.regedit_item)

    self.wineprefix_item = wx.MenuItem(self.expertmenu, 104, _("Update the wineprefix"))
    self.wineprefix_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/menu/wineprefix.png"))
    self.expertmenu.AppendItem(self.wineprefix_item)

   # self.directx_item = wx.MenuItem(self.expertmenu, 106, _("Install DirectX"))
  #  self.directx_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/menu/directx.png"))
 #   self.expertmenu.AppendItem(self.directx_item)

    self.expertmenu.AppendSeparator()

    self.winever_item = wx.MenuItem(self.expertmenu, 107, _("Manage wine versions"))
    self.winever_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/menu/wine.png"))
    self.expertmenu.AppendItem(self.winever_item)

    self.wineserv_item = wx.MenuItem(self.expertmenu, 115, _("Kill wineserver process"))
    self.wineserv_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/menu/wineserver.png"))
    self.expertmenu.AppendItem(self.wineserv_item)

    self.run_item = wx.MenuItem(self.expertmenu, 108, _("Run a non-official script"))
    self.run_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/menu/run.png"))
    self.expertmenu.AppendItem(self.run_item)

    self.polshell_item = wx.MenuItem(self.expertmenu, 109, _("PlayOnLinux debugger"))
    self.polshell_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/menu/polshell.png"))
    self.expertmenu.AppendItem(self.polshell_item)

    self.optionmenu = wx.Menu()

    self.option_item = wx.MenuItem(self.expertmenu, 210, _("General"))
    self.option_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/input-gaming.png"))
    self.optionmenu.AppendItem(self.option_item)

    self.option_item = wx.MenuItem(self.expertmenu, 211, _("Messenger"))
    self.option_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/internet-group-chat.png"))
    self.optionmenu.AppendItem(self.option_item)

    self.option_item = wx.MenuItem(self.expertmenu, 212, _("Internet"))
    self.option_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/internet-web-browser.png"))
    self.optionmenu.AppendItem(self.option_item)

    self.option_item = wx.MenuItem(self.expertmenu, 213, _("Environement"))
    self.option_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/user-desktop.png"))
    self.optionmenu.AppendItem(self.option_item)

    self.option_item = wx.MenuItem(self.expertmenu, 214, _("System"))
    self.option_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/application-x-executable.png"))
    self.optionmenu.AppendItem(self.option_item)

    self.option_item = wx.MenuItem(self.expertmenu, 215, _("Plugins"))
    self.option_item.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/package-x-generic.png"))
    self.optionmenu.AppendItem(self.option_item)

    self.pluginsmenu = wx.Menu()

    files=os.listdir(Variables.playonlinux_rep+"/plugins")
    files.sort()
    self.plugin_list = []
    self.i = 0
    self.j = 0
    while(self.i < len(files)):
	if(os.path.exists(Variables.playonlinux_rep+"/plugins/"+files[self.i]+"/scripts/menu")):
		if(os.path.exists(Variables.playonlinux_rep+"/plugins/"+files[self.i]+"/enabled")):
			self.plugin_item = wx.MenuItem(self.expertmenu, 300+self.j, files[self.i])

			self.icon_look_for = Variables.playonlinux_rep+"/plugins/"+files[self.i]+"/icon"
			if(os.path.exists(self.icon_look_for)):
				self.bitmap = wx.Bitmap(self.icon_look_for)
			else:	
				self.bitmap = wx.Bitmap(Variables.playonlinux_env+"/etc/playonlinux16.png")
			
			self.plugin_item.SetBitmap(self.bitmap)
			self.pluginsmenu.AppendItem(self.plugin_item)
			wx.EVT_MENU(self, 300+self.j,  self.run_plugin)
			self.plugin_list.append(files[self.i])
			self.j += 1
	self.i += 1
    
    if(self.j > 0):
	self.pluginsmenu.AppendSeparator()

    self.option_item_p = wx.MenuItem(self.expertmenu, 215, _("Plugins manager"))
    self.option_item_p.SetBitmap(wx.Bitmap(Variables.playonlinux_env+"/etc/onglet/package-x-generic.png"))
    self.pluginsmenu.AppendItem(self.option_item_p)
 
    self.last_string = ""


    # /!\ id 115 utilisé par wineserver #
    # /!\ id 117 et 118 utilisés aussi #
    self.helpmenu = wx.Menu()
    self.helpmenu.Append(wx.ID_ABOUT, _("About"))

    self.menubar = wx.MenuBar()
    self.menubar.Append(self.filemenu, _("File"))
    self.menubar.Append(self.expertmenu, _("Tools"))
    self.menubar.Append(self.optionmenu, _("Settings"))
    self.menubar.Append(self.pluginsmenu, _("Plugins"))
    self.menubar.Append(self.helpmenu, _("Help"))
    self.SetMenuBar(self.menubar)

    self.toolbar = self.CreateToolBar(wx.TB_TEXT)
    self.toolbar.AddLabelTool(wx.ID_OPEN, _("Run"), wx.ArtProvider.GetBitmap("gtk-open", wx.ART_TOOLBAR))
    self.toolbar.AddLabelTool(wx.ID_ADD, _("Install"), wx.ArtProvider.GetBitmap("gtk-add", wx.ART_TOOLBAR))
    self.toolbar_remove = self.toolbar.AddLabelTool(wx.ID_DELETE, _("Remove"), wx.ArtProvider.GetBitmap("gtk-delete", wx.ART_TOOLBAR))
    self.toolbar.AddLabelTool(wx.ID_REFRESH, _("Update"), wx.ArtProvider.GetBitmap("gtk-refresh", wx.ART_TOOLBAR))
    self.toolbar.AddLabelTool(120, _("Autorun"), wx.ArtProvider.GetBitmap("gtk-cdrom", wx.ART_TOOLBAR))
    self.Reload(self)
    wx.EVT_MENU(self, wx.ID_OPEN,  self.Run)
    wx.EVT_MENU(self, wx.ID_ADD,  self.InstallMenu)
    wx.EVT_MENU(self, wx.ID_ABOUT,  self.About)
    wx.EVT_MENU(self,  wx.ID_EXIT,  self.ClosePol)
    wx.EVT_MENU(self,  wx.ID_REFRESH,  self.UpdatePol)
    wx.EVT_MENU(self,  wx.ID_DELETE,  self.UninstallGame)
    

    # Expert
    wx.EVT_MENU(self, 101,  self.Reload)
    wx.EVT_MENU(self, 102,  self.ConfigureWine)
    wx.EVT_MENU(self, 103,  self.Regedit)
    wx.EVT_MENU(self, 104,  self.UpdatePrefixe)
   # wx.EVT_MENU(self, 106,  self.DirectX)
    wx.EVT_MENU(self, 107,  self.WineVersion)
    wx.EVT_MENU(self, 108,  self.Executer)
    wx.EVT_MENU(self, 109,  self.PolShell)
    wx.EVT_MENU(self, 115,  self.killwineserver)
    wx.EVT_MENU(self, 117,  self.WineBooster)
    wx.EVT_MENU(self, 120,  self.Autorun)

    #Options
    wx.EVT_MENU(self, 210,  self.Options)
    wx.EVT_MENU(self, 211,  self.Options)
    wx.EVT_MENU(self, 212,  self.Options)
    wx.EVT_MENU(self, 213,  self.Options)
    wx.EVT_MENU(self, 214,  self.Options)
    wx.EVT_MENU(self, 215,  self.Options)
    wx.EVT_TREE_SEL_CHANGED(self, 127,  self.change_irc_window)

    wx.EVT_CLOSE(self, self.ClosePol)
    wx.EVT_TREE_ITEM_ACTIVATED(self, 105, self.Run)
    wx.EVT_TREE_SEL_CHANGED(self, 105, self.Select)
    #wx.EVT_TREE_ITEM_MENU(self, 105, self.OnRightDown)

    #Timer, regarde toute les secondes si il faut actualiser la liste
    self.Bind(wx.EVT_TIMER, self.AutoReload, self.timer)
    self.timer.Start(200)


  def DisableAll(self):
	#self.directx_item.Enable(False)
	self.wineconfig_item.Enable(False)
#	self.wbooster_item.Enable(False)
	self.regedit_item.Enable(False)
	self.wineprefix_item.Enable(False)

  def EnableAll(self):
	#self.directx_item.Enable(True)
	self.wineconfig_item.Enable(True)
#	self.wbooster_item.Enable(True)
	self.regedit_item.Enable(True)
	self.wineprefix_item.Enable(True)

  def Select(self, event):
	game_exec = self.onglets.list_game.GetItemText(self.onglets.list_game.GetSelection())
	self.read = open(Variables.playonlinux_rep+"configurations/installed/"+game_exec,"r").readlines()
	self.i = 0;
	self.wine_present = False;
	while(self.i < len(self.read)):
		if("wine " in self.read[self.i]):
			self.wine_present = True;
		self.i += 1
	if(self.wine_present == True):
		self.EnableAll()
	else:
		self.DisableAll()

  def Reload(self, event):
	 game_exec = self.onglets.list_game.GetItemText(self.onglets.list_game.GetSelection())
	 self.DisableAll()
	 #self.remove_item_menu.Enable(False)
	# self.toolbar.Enable(False)
	 self.games = os.listdir(Variables.playonlinux_rep+"configurations/installed/")
	 self.games.sort()
	 self.onglets.images.RemoveAll()
	 for game in self.games: #METTRE EN 32x32
		if(os.path.exists(Variables.playonlinux_rep+"/icones/32/"+game)):
			file_icone = Variables.playonlinux_rep+"/icones/32/"+game
		else:
			file_icone = Variables.playonlinux_rep+"/icones/32/playonlinux.png"
		self.onglets.images.Add(wx.Bitmap(file_icone));

	 self.onglets.list_game.DeleteAllItems()
	 root = self.onglets.list_game.AddRoot("")
	    
	 self.i = 0
	 for game in self.games:
		item = self.onglets.list_game.AppendItem(root, game, self.i)
		self.i = self.i+1
	
  def Options(self, event):
    print("Running options")
    onglet=event.GetId()-210
    os.system(os.popen("printf $PYTHON",'r').read()+" \""+Variables.playonlinux_env+"/python/options.py\" "+str(onglet)+"&")

  def run_plugin(self, event):
    game_exec = self.onglets.list_game.GetItemText(self.onglets.list_game.GetSelection())
    plugin=self.plugin_list[event.GetId()-300]
    try :
	os.system("bash \""+Variables.playonlinux_rep+"/plugins/"+plugin+"/scripts/menu\" \""+game_exec+"\"&")
    except : 
	print("bash \""+Variables.playonlinux_rep+"/plugins/"+plugin+"/scripts/menu\" "+game_exec+"&")

  def Lng_choose(self, event):
    print("Running lng_choose")
    os.system("bash \""+Variables.playonlinux_env+"/bash/options/lng_choose\"&")

  def Repository(self, event):
    print("Running repository")
    os.system("bash \""+Variables.playonlinux_env+"/bash/options/repository\"&")
  
  def Panels(self, event):
    print("Running panel")
    os.system("bash \""+Variables.playonlinux_env+"/bash/options/panel\"&")

  def Informations(self, event):
    print("Running informations menu")
    os.system("bash \""+Variables.playonlinux_env+"/bash/options/infos\"&")

  def Theme(self, event):
    print("Running themes menu")
    os.system("bash \""+Variables.playonlinux_env+"/bash/options/themes\"&")

  def killwineserver(self, event):
    print("Running kill wineserver")
    os.system("bash \""+Variables.playonlinux_env+"/bash/expert/kill_wineserver\"&")

 # def DirectX(self, event):
 #   game_exec = self.onglets.list_game.GetItemText(self.onglets.list_game.GetSelection())
  #  if(game_exec != ""):
    #    print("Running DirectX Setup")
   ##	os.system("bash \""+Variables.playonlinux_env+"/bash/expert/DirectX\" \""+game_exec+"\"&")

  def UpdatePrefixe(self, event):
    game_exec = self.onglets.list_game.GetItemText(self.onglets.list_game.GetSelection())
    if(game_exec != ""):
        print("Running wineprefixecreate")
   	os.system("bash \""+Variables.playonlinux_env+"/bash/expert/UpdatePrefixe\" \""+game_exec+"\"&")

  def Executer(self, event):
    print("Running exec")
    os.system("bash \""+Variables.playonlinux_env+"/bash/expert/Executer\"&")
 

  def WineBooster(self, event):
    game_exec = self.onglets.list_game.GetItemText(self.onglets.list_game.GetSelection())
    if(game_exec != ""):
	    print("Running WineBooster\n Merci à GNU_Raziel")
	    os.system("bash \""+Variables.playonlinux_env+"/bash/expert/WineBooster2\" \""+game_exec+"\"&")

  def PolShell(self, event):
    print("Running PolShell")
    os.system("bash \""+Variables.playonlinux_env+"/bash/expert/PolShell\"&")

  def Regedit(self, event):
    game_exec = self.onglets.list_game.GetItemText(self.onglets.list_game.GetSelection())
    if(game_exec != ""):
        print("Running regedit")
   	os.system("bash \""+Variables.playonlinux_env+"/bash/expert/BaseDeRegistre\" \""+game_exec+"\"&")

  def UninstallGame(self, event):
    game_exec = self.onglets.list_game.GetItemText(self.onglets.list_game.GetSelection())
    if(game_exec != ""):
        print("Uninstall "+game_exec)
   	os.system("bash \""+Variables.playonlinux_env+"/bash/uninstall\" \""+game_exec+"\"&")

  def ConfigureWine(self, event):
    game_exec = self.onglets.list_game.GetItemText(self.onglets.list_game.GetSelection())
    if(game_exec != ""):
        print("Running wineconfig")
   	os.system("bash \""+Variables.playonlinux_env+"/bash/expert/WineConfig\" \""+game_exec+"\"&")

  def change_irc_window(self, event):
	self.irc_user_list(self)
	self.html_reload(self)
	#print self.onglets.window.GetItemText(self.onglets.window.GetSelection())
  def irc_key(self, item):
    if(item[0] == "~"):
	return ("A")
    else:
	if(item[0] == "@" or item[0] == "&"):
		return ("B")
	else :
       	  if(item[0] == "%"):
          	return ("C")
	  else:
		if(item[0] == "+"):
          		return ("D")
		else:
			return string.lower(item[0])

  def html_reload(self, event):
	  self.window_txt = self.onglets.window.GetItemText(self.onglets.window.GetSelection()).encode("utf-8")
	  irc.selected_window = self.window_txt
	  self.chat_content = ""
	  # On regarde quelle liste on va prendre
	  id_liste = irc.get_index(self.window_txt)
      	  # On ajoute tout
	  self.i = 0
	  if(len(irc.messages[id_liste]) >= 300):
		del irc.messages[id_liste][0]
	 
	  while(self.i < len(irc.messages[id_liste])):
		if(self.i != 0):
			self.chat_content += "\n<br />"
		self.chat_content += irc.messages[id_liste][self.i]
		self.i += 1
  	  self.onglets.content.SetPage("<html><head></head><body><p align='left'>"+self.chat_content+"</p></body></html>")
	  self.onglets.content.Scroll(0,len(irc.messages[id_liste])*2)

  def html_reload_status(self, event):
	  self.chat_content = ""
	  # On regarde quelle liste on va prendre
	  self.i = 0
 	  if(len(irc.status_messages) >= 300):
		del irc.status_messages[0]

	  while(self.i < len(irc.status_messages)):
		self.chat_content += irc.status_messages[self.i]+"<br />\n"
		self.i += 1
  	  self.onglets.content.SetPage("<html><head></head><body><p align='left'>"+self.chat_content+"</p></body></html>")
 	  self.onglets.content.Scroll(0,len(irc.status_messages)*2)

  def irc_user_list(self, event):
	self.window_txt = self.onglets.window.GetItemText(self.onglets.window.GetSelection()).encode("utf-8").lower()

	irc.selected_window = self.window_txt
	# On casse tout
	self.onglets.buddy.DeleteAllItems()	
	self.buddy_root = self.onglets.buddy.AddRoot("")
	# On regarde quelle liste on va prendre
	id_liste = irc.get_index(self.window_txt)
	# On ajoute tout
	self.user_i = 0
	while(self.user_i < len(irc.names[id_liste])):
		num = 3
		irc.names[id_liste].sort(key=self.irc_key)
		if("@" in irc.names[id_liste][self.user_i] or "&" in irc.names[id_liste][self.user_i]):
			num = 0
		if("~" in irc.names[id_liste][self.user_i]):
			num = 4
		if("%" in irc.names[id_liste][self.user_i]):
			num = 1
		if("+" in irc.names[id_liste][self.user_i]):
			num = 2
		self.onglets.buddy.AppendItem(self.buddy_root, irc.names[id_liste][self.user_i].replace("&","").replace("~","").replace("%","").replace("+","").replace("@",""), num)
		html_hex = irc.GenColor(irc.names[id_liste][self.user_i].replace("&","").replace("~","").replace("%","").replace("+","").replace("@",""))
		self.couleur = [pow(int(html_hex[2],16),2),pow(int(html_hex[3],16),2),pow(int(html_hex[4],16),2)]
		self.onglets.buddy.SetItemTextColour(self.onglets.buddy.GetLastChild(self.buddy_root), wx.Colour(int(self.couleur[0]),int(self.couleur[1]),int(self.couleur[2])))
		self.user_i += 1
	wx.Yield()

  def AutoReload(self, event):
    self.new_string = irc.string_to_write
    # print irc.string_to_write

    reload = os.listdir(Variables.playonlinux_rep+"/configurations/installed")
    if(reload != self.oldreload):
	self.Reload(self)
	self.oldreload = reload

    reloadimg = os.listdir(Variables.playonlinux_rep+"/icones/32")
    if(reloadimg != self.oldimg):
	self.Reload(self)
	self.oldimg = reloadimg

    if(irc.ircconnected == True):
	if(self.chans != irc.chans):
		self.onglets.OpenWindow()
		self.chans = irc.chans[:]
		#print "Refresh"
	#else :
	#print str(self.chans)+" --- "+str(irc.chans)
		
	self.window_txt = self.onglets.window.GetItemText(self.onglets.window.GetSelection()).encode("utf-8").lower()
	
	if(len(self.window_txt) > 0):
		id_liste = irc.get_index(self.window_txt)
		if(self.window_txt[0] == "#"):
			#print self.names
			if(irc.names[id_liste] != self.names):
				self.irc_user_list(self)
				self.names = irc.names[id_liste][:]

	#if(len(irc.messages) > id_liste+1):

		if(irc.messages[id_liste] != self.messages):
			self.html_reload(self)
			self.messages = irc.messages[id_liste][:]

	if(irc.select_window != ""):
		self.onglets.selectWindow(irc.select_window)
		irc.select_window = ""
	
	if(self.onglets.window.GetItemText(self.onglets.window.GetSelection()) != irc.selected_window):
		irc.selected_window = self.onglets.window.GetItemText(self.onglets.window.GetSelection())
	if(irc.selected_window == "#playonlinux"):
		self.onglets.close.Enable(False)
	else:
		self.onglets.close.Enable(True)

	
	self.onglets.connect.Enable(False)
	self.onglets.disconnect.Enable(True)
	if(len(self.chans) == 0):
		if(irc.status_messages != self.messages):
			self.html_reload_status(self)
			self.messages = irc.status_messages[:]
    else:
	if(irc.status_messages != self.messages):
		self.html_reload_status(self)
		self.messages = irc.status_messages[:]

	self.onglets.buddy.DeleteAllItems()
	self.onglets.window.DeleteAllItems()
	self.onglets.connect.Enable(True)
	self.onglets.disconnect.Enable(False)
	if(self.settings["AUTOCONNECT"] == "1"):
		if(self.already_connected == False):
			irc.Nick = self.onglets.nickname.GetValue().encode("utf-8")
			irc.connect()
			self.already_connected = True;

  def InstallMenu(self, event):
    print("Running install menu")
    os.system("bash \""+Variables.playonlinux_env+"/bash/install\"&")
    
  def UpdatePol(self, event):
    print("Running update menu")
    os.system("bash \""+Variables.playonlinux_env+"/bash/check_maj\"&")
  
  def Autorun(self, event):
    print("Autorun")
    os.system("bash \""+Variables.playonlinux_env+"/bash/autorun\"&")

  def WineVersion(self, event):
    print("Running wineversion menu")
    os.system("bash \""+Variables.playonlinux_env+"/bash/wineversion\"&")

  def Run(self, event):
    game_exec = self.onglets.list_game.GetItemText(self.onglets.list_game.GetSelection()).encode("utf-8")
    if(game_exec != ""):
	print("Running "+game_exec)
	if(self.settings["ALERT"] == "1"):
		irc.SendMSG("/me is playing : "+game_exec,irc.chanAutoJoin)

	os.system("cd \""+Variables.playonlinux_rep+"/configurations/installed/\" && bash \""+game_exec+"\"&")


  def ClosePol(self, event):
    irc.stop()
    irc._Thread__stop()
    time.sleep(0.3)
    sys.exit(0)
    
  def About(self, event):
    self.aboutBox = wx.AboutDialogInfo()
    self.aboutBox.SetIcon(wx.Icon(Variables.playonlinux_env+"/etc/playonlinux.png", wx.BITMAP_TYPE_ANY))
    self.aboutBox.SetName("PlayOnLinux")
    self.aboutBox.SetVersion(Variables.version)
    self.aboutBox.SetDescription(_("Run your Windows programs on Linux !"))
    self.aboutBox.SetCopyright(_("(C) PlayOnLinux team 2008\nUnder GPL licence version 3"))
    self.aboutBox.AddDeveloper("Developer and Website : Tinou (Pâris Quentin)")	 
    self.aboutBox.AddDeveloper("Website : Goku (Picaut Antoine)")
    self.aboutBox.AddDeveloper("Scriptors : MulX (Petit Aymeric), GNU_Raziel")
    self.aboutBox.AddDeveloper("Packager : MulX (Petit Aymeric)")
    self.aboutBox.AddDeveloper("Script Creator : Zoloom (Cassarin-Grand Arthur)")
    self.aboutBox.AddDeveloper("Helped for the program : kiplantt")
    self.aboutBox.AddArtist("Icons are provided by Tango Desktop Project")
    self.aboutBox.SetWebSite("http://www.playonlinux.com")
    self.aboutBox.SetLicence(open(Variables.playonlinux_env+"/LICENCE",'r').read())
    self.about = wx.AboutBox(self.aboutBox)

class PlayOnLinuxApp(wx.App):
   def OnInit(self):
	self.frame = MainWindow(None, -1, "PlayOnLinux")
        self.SetTopWindow(self.frame)
	self.frame.Center(wx.BOTH)
       	self.frame.Show(True)
        return True



lng.Lang()
#read = PlayOnLinuxRead()
app = PlayOnLinuxApp()
irc = irc.IRCClient()
app.MainLoop()
#irc.connexion.send("QUIT www.playonlinux.com")
sys.exit(0)
